var is_exit = false;
var baseurl = 'http://www.mamilist.com/';
var app_version = '20150602';
angular.module('starter', ['ionic', 'starter.controllers', 'starter.services'])
    .run(function ($ionicPlatform, $state, $timeout, ApiService) {
        $ionicPlatform.ready(function () {
            if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                //https://github.com/driftyco/ionic/issues/2256
                cordova.plugins.Keyboard.disableScroll(true);
            }
            if (window.cordova && window.cordova.plugins && window.cordova.plugins.InAppBrowser) {
                window.open = cordova.plugins.InAppBrowser.open;
            }
            if (window.StatusBar) {
                StatusBar.styleLightContent();
            }
            if (window.cordova && navigator.connection.type == Connection.NONE) {
                showMsg('无法连接到网络');
            }
            $ionicPlatform.registerBackButtonAction(function (e) {
                var mainmenus = {
                    'tab.home': 1,
                    'tab.qingdans': 1,
                    'tab.discover': 1,
                    'tab.me': 1
                }
                mainmenus[$state.current.name] = mainmenus[$state.current.name] || false;
                if ($state.current.name == 'tab.home') {
                }
                if (mainmenus[$state.current.name] === 1) {
                    if (is_exit) {
                        navigator.app.exitApp();
                    } else {
                        showMsg('再按一次退出妈妈清单');
                        is_exit = true;
                        $timeout(function () {
                            is_exit = false;
                        }, 5000)
                    }
                }
                else {
                    navigator.app.backHistory();
                }
            }, 100);
            $timeout(function () {
                $state.go('tab.home', {}, {location: 'replace'});
            }, 1800)
        });
    })
    .config(['$httpProvider', function ($httpProvider, $timeout) {
        $httpProvider.defaults.timeout = 3000;
        var configLoading = function () {
            $httpProvider.interceptors.push(function ($rootScope) {
                return {
                    request: function (config) {
                        $rootScope.$broadcast('loading:show')
                        return config
                    },
                    requestError: function (rejection) {
                        $rootScope.$broadcast('loading:error')
                        return false
                    },
                    responseError: function (rejection) {
                        $rootScope.$broadcast('loading:error')
                        return false
                    },
                    response: function (response) {
                        $rootScope.$broadcast('loading:hide')
                        return response
                    }
                }
            })
        }
        configLoading();
    }])
    .config(function ($ionicConfigProvider) {
        $ionicConfigProvider.tabs.style('ios');
        $ionicConfigProvider.tabs.position("bottom");
        $ionicConfigProvider.navBar.alignTitle("center");
    })
    .config(function ($stateProvider, $urlRouterProvider) {
        $stateProvider
            .state('tab', {
                url: '/tab',
                abstract: true,
                templateUrl: 'templates/tabs.html'
            })
            // Each tab has its own nav history stack:
            .state('tab.home', {
                url: '/home',
                views: {
                    'tab-home': {
                        templateUrl: 'templates/home.html',
                        controller: 'HomeCtrl'
                    }
                }
            })
            .state('tab.step', {
                url: '/step/:step',
                views: {
                    'tab-qingdans': {
                        templateUrl: 'templates/step.html',
                        controller: 'StepCtrl'
                    }
                }
            })
            .state('tab.qingdans', {
                url: '/qingdans',
                views: {
                    'tab-qingdans': {
                        templateUrl: 'templates/qingdans.html',
                        controller: 'QingdansCtrl'
                    }
                }
            })
            .state('tab.discover', {
                url: '/discover',
                views: {
                    'tab-discover': {
                        templateUrl: 'templates/discover.html',
                        controller: 'DiscoverCtrl'
                    }
                }
            })
            .state('tab.me', {
                url: '/me',
                views: {
                    'tab-me': {
                        templateUrl: 'templates/me.html',
                        controller: 'MeCtrl'
                    }
                }
            })
            .state('tab.favs', {
                url: '/favs',
                views: {
                    'tab-favs': {
                        templateUrl: 'templates/favs.html',
                        controller: 'FavsCtrl'
                    }
                }
            })
            .state('tab.about', {
                url: '/about/:id',
                views: {
                    'tab-me': {
                        templateUrl: 'templates/about.html',
                        controller: 'AboutCtrl'
                    }
                }
            });
        // if none of the above states are matched, use this as the fallback
    });
function showMsg(msg) {
    msg = msg || '无法连接到网络';
    if (window.plugins) {
        window.plugins.toast.showShortBottom(msg);
    } else {
        alert(msg);
    }
    return false;
}
function GoodsToFloors(goods, favs) {
    var floors = [];
    goods = fixImgPath(goods, 'thumb');
    goods.map(function (vo, ik) {
        if (favs.goods.indexOf(vo.good_id) === -1) {
            vo.isFav = '';
        } else {
            vo.isFav = 'fav';
        }
        var yushu = (ik + 1) % 2;
        if (yushu === 0) {
            var goodl = goods[ik - 1];
            var goodr = goods[ik];
            floors.push([goodl, goodr]);
        }
    });
    if (goods.length % 2 === 1) {
        var goodl = goods[goods.length - 1];
        floors.push([goodl]);
    }
    return floors;
}
var fixImgPath = function (arrs, imgf) {
    imgf = imgf || 'img';
    if (!arrs) {
        return 'img/null.jpg';
    }
    if (window.cordova && navigator.connection.type == Connection.NONE) {
        return 'img/null.jpg';
    }
    if (typeof arrs === 'string') {
        return baseurl_img + arrs;
    }
    return arrs.map(function (vo) {
        vo[imgf] = vo[imgf] || "";
        if (vo[imgf]) {
            vo.img = baseurl_img + vo[imgf];
        } else {
            vo.img = 'img/null.jpg';
        }
        return vo;
    });
}
var randColor = function (index) {
    var colors = ['bg1', 'bg3', 'bg2', 'bg5', 'bg4', 'bg6', 'bg8', 'bg7', 'bg9'];
    index = index % colors.length;
    return colors[index];
}
var scroll2Top = function ($Delegate, sid) {
    $Delegate._instances.map(function (sc) {
        if (sc.$$delegateHandle == sid) {
            sc.resize();
            sc.scrollTop()
        }
    });
}
var getItemHeight = function (vwrate) {
    var vwpx = document.body.offsetWidth;
    if (vwpx > 380) {
        return vwpx / 100 * (vwrate - 2);
    }
    return parseInt(vwpx / 100 * (vwrate - 0));
}