angular.module('starter.controllers', [])
    .filter('trustHtml', ['$sce', function ($sce) {
        return function (text) {
            return $sce.trustAsHtml(text);
        };
    }]).run(function ($rootScope, $ionicLoading, $ionicHistory, $ionicPopup, ApiService, appModals, $location) {
        $rootScope.$on('loading:show', function () {
            $ionicLoading.show({template: '<img src="img/loading.gif"/>'})
        })
        $rootScope.$on('loading:hide', function () {
            $ionicLoading.hide()
        })
        $rootScope.$on('loading:error', function () {
            $ionicLoading.hide()
        })
        ApiService.stats('open');
        $rootScope.goURI = function (turi) {
            console.log(turi);
            uriarr = turi.split('/');
            if (uriarr.length == 2) {
                if (uriarr[0] === 'good') {
                    appModals.good(uriarr[1]);
                }
                if (uriarr[0] === 'gonglue') {
                    appModals.gonglue(uriarr[1]);
                }
                if (uriarr[0] === 'goodcate') {
                    $location.path('/menu/tab/list/' + uriarr[1]).replace();
                }
                if (uriarr[0] === 'goodtopic') {
                    $location.path('/menu/tab/topic/' + uriarr[1]).replace();
                }
                return true;
            }
            if (turi === 'liwuso') {
                $location.path('/menu/tab/liwuso').replace();
            }
        }
        $rootScope.share = function (dinfo, type) {
            type = type || 'app';
            var subj = '来自妈妈清单的分享';
            var shtext = '';// rsdata.url
            if (type == 'app') {
                shtext = '我发现了一个不错的妈妈清单网站，你以后给宝宝买东东可能用得上，去看看吧。【妈妈清单网】http://www.mamilist.com/';
            }
            if (type == 'qingdan') {
                shtext = '【' + dinfo.name + '】' + dinfo.des + 'http://www.mamilist.com/qingdan/' + dinfo.id;
            }
            window.plugins.socialsharing.share(shtext, subj);
        };
        $rootScope.goBack = function (touri) {
            touri = touri || false;
            if (touri) {
                $ionicHistory.goBack();
                $ionicHistory.clearHistory();
                $location.path('/tab/' + touri).replace();
            } else {
                $ionicHistory.goBack();
            }
        };
        $rootScope.goTaobao = function (good) {
            ApiService.stats('gobuy');
            var gobuyurl = good.tkurl3 || good.tkurl2;
            gobuyurl = gobuyurl || good.tkurl;
            if (!gobuyurl) return false;
            cordova.ThemeableBrowser = cordova.ThemeableBrowser || window;
            //var ref = window.open(gobuyurl, '_blank', 'location=yes,toolbar=no,hardwareback=no,clearcache=no');
            cordova.ThemeableBrowser.open(gobuyurl, '_blank', {
                toolbar: {
                    height: 44,
                    color: '#C40000'
                },
                backButton: {
                    align: 'left'
                },
                title: {
                    color: '#FFFFFF',
                    staticText: '宝贝详情-淘宝',
                    showPageTitle: false
                },
                forwardButton: {},
                closeButton: {
                    wwwImage: 'img/back.png',
                    wwwImagePressed: 'img/back.png',
                    wwwImageDensity: 2
                },
                menu: {
                    wwwImage: 'img/menu.png',
                    wwwImagePressed: 'img/menu.png',
                    wwwImageDensity: 2,
                    title: '打开方式',
                    cancel: '取消',
                    align: 'right',
                    items: [
                        {
                            event: 'systemPressed',
                            label: '系统浏览器打开'
                        }
                    ]
                },
                backButtonCanClose: true
            }).addEventListener('systemPressed', function (e) {
                cordova.ThemeableBrowser.open(gobuyurl, '_system');
            })
            addEventListener('sharePressed', function (e) {
                var subj = '来自 妈妈清单 的分享';
                window.plugins.socialsharing.share(gobuyurl, subj);
            }).addEventListener('closePressed', function (e) {
                window.close();
            });
        }
        $rootScope.viewGood = function (item_id) {
            if (typeof  item_id == "object") {
                item_id = item_id.good_id;
            }
            appModals.good(item_id);
        }
        $rootScope.viewQingdan = function (item_id) {
            if (typeof  item_id == "object") {
                item_id = item_id.id;
            }
            appModals.qingdan(item_id);
        };
        $rootScope.likeGonglue = function (gonglue) {
            ApiService.like(gonglue, 'gonglue');
        };
        $rootScope.like = function (info) {
            ApiService.like(info);
        };
    })
    .controller('HomeCtrl', function ($scope, ApiService, $state) {
        console.log('HomeCtrl');
        ApiService.me(null, function (err, minfo) {
            if (!minfo) {
                return $state.transitionTo('tab.me');
            }
            if (minfo.type == 0) {
                return $state.transitionTo('tab.me');
            }
        })
        $scope.qingdans = [];
        ApiService.hotqingdans().then(function (rsdata) {
            for (fkey in rsdata) {
                rsdata[fkey].color = ApiService.randColor(fkey);
            }
            $scope.qingdans = rsdata;
            console.log(rsdata);
        })
    })
    .controller('StepCtrl', function ($scope, $stateParams, ApiService) {
        console.log('StepCtrl');
        $scope.qingdans = [];
        var step = $stateParams.step;
        ApiService.qingdans(step).then(function (rsdata) {
            for (fkey in rsdata) {
                rsdata[fkey].color = ApiService.randColor(fkey);
            }
            $scope.qingdans = rsdata;
            console.log(rsdata);
        })
    })
    .controller('QingdansCtrl', function ($scope, ApiService) {
        console.log('QingdansCtrl');
        $scope.steps = [];
        ApiService.steps().then(function (rsdata) {
            for (fkey in rsdata) {
                rsdata[fkey].color = ApiService.randColor(fkey);
            }
            $scope.steps = rsdata;
            console.log(rsdata);
        })

    })
    .controller('AboutCtrl', function ($scope, $stateParams, ApiService) {
        console.log('AboutCtrl');
        $scope.info = {};
        var step = $stateParams.id;
        ApiService.info(step).then(function (rsdata) {
            $scope.info = rsdata;
            console.log(rsdata);
        })
    })
    .controller('DiscoverCtrl', function ($scope, ApiService, $ionicScrollDelegate) {
        $scope.gbases = [];
        $scope.shuffle = function () {
            ApiService.me(null, function (err, rs) {
                $scope.mami = rs;
                ApiService.push(rs.type, rs.time, function (rsdata) {
                    var t = {};
                    t.p = rsdata;
                    ApiService.favs(t, function () {
                        $scope.gbases = t.p;
                        console.log(rsdata);
                    })
                    scroll2Top($ionicScrollDelegate, 'discoverScroll')
                });
            });
        }
        $scope.shuffle();
    })
    .controller('MeCtrl', function ($scope, ApiService, $ionicModal, $state, $ionicHistory) {
        $scope.metype = 0;
        $scope.meweek = 0;
        $scope.meday = 1;
        $scope.meyear = new Date().getFullYear();
        $scope.memonth = 1;
        $scope.types = [
            { name: '努力备孕中', id: 1},
            { name: '已怀孕啦', id: 2},
            { name: '乖宝宝已出生', id: 3}
        ];
        $scope.setMamiType = function () {
            $ionicModal.fromTemplateUrl('templates/me-set-type.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                modal.show();
                $scope.typemodal = modal;
            });
        }
        $scope.setVal = function (index, me) {
            $scope[index] = me[index];
        }
        $scope.setMamiDate = function (type) {
            $scope.metype = type.id;
            $scope.typemodal.hide();
            if (type.id == 1) {
                $scope.setMamiOk();
                $scope.redirect = 1;
            }
            if (type.id == 2) {
                $ionicModal.fromTemplateUrl('templates/me/set-unborn.html', {
                    scope: $scope,
                    backdropClickToClose: true,
                    hardwareBackButtonClose: true,
                    animation: 'slide-in-up'
                }).then(function (modal) {
                    modal.show();
                    $scope.bmodal = modal;
                });
            }
            if (type.id == 3) {
                $ionicModal.fromTemplateUrl('templates/me/set-borned.html', {
                    scope: $scope,
                    backdropClickToClose: true,
                    hardwareBackButtonClose: true,
                    animation: 'slide-in-up'
                }).then(function (modal) {
                    modal.show();
                    $scope.cmodal = modal;
                });
            }
        }
        $scope.setMamiOk = function () {
            var info = {}
            if ($scope.metype == 1) {
                info.type = 1;
            }
            if ($scope.metype == 2) {
                info.type = 2;
                info.week = $scope.meweek;
                info.day = $scope.meday;
                $scope.bmodal.hide();
            }
            if ($scope.metype == 3) {
                info.type = 3;
                info.year = $scope.meyear;
                info.month = $scope.memonth;
                info.day = $scope.meday;
                $scope.cmodal.hide();
            }
            //info.reload = true;
            $ionicHistory.clearCache();
            ApiService.me(info, function (err, rs) {
                $scope.mami = rs;
                if ($scope.redirect) {
                    $scope.redirect = 0;
                    $state.transitionTo('tab.home');
                }
            });
        }
        ApiService.me(null, function (err, rs) {
            if (!rs) {
                $scope.redirect = 1;
                $scope.setMamiType();
                return false;
            }
            if (rs.type == 0) {
                $scope.redirect = 1;
                $scope.setMamiType();
                return false;
            }
            $scope.mami = rs;
        });
    }).controller('FavsCtrl', function ($scope, ApiService, $location, $ionicScrollDelegate) {
        console.log('MeCtrl');
        $scope.dapack = {};
        $scope.is_empty = false;
        $scope.showTab = function (tabid) {
            if (tabid == 0) {
                $scope.tab0 = true;
                $scope.tab1 = false;
                $scope.tabc = ['tab-item-active', ''];
            } else {
                $scope.tab0 = false;
                $scope.tab1 = true;
                $scope.tabc = ['', 'tab-item-active'];
            }
        }
        $scope.showTab(0);
        ApiService.mylist(function (rsdata) {
            $scope.dapack = rsdata;
        });
        $scope.unlike = function (info, type) {
            ApiService.like(info, type, function () {
                ApiService.mylist(function (rsdata) {
                    $scope.dapack = rsdata;
                    $scope.num = $scope.dapack.mami.length + $scope.dapack.mami.length
                    $ionicScrollDelegate.resize();
                });
            })
        }
        var oldpos = '';
        var old_y = 0;
        $scope.scrollTo = function (id) {
            $location.hash('qde_' + id);
            oldpos = id;
            $ionicScrollDelegate._instances.map(function (sc) {
                if (sc.$$delegateHandle == 'meScroll') {
                    old_y = sc.getScrollPosition().top;
                    if (oldpos == 'menu' && id == 'menu') {
                        sc.scrollTo(0, old_y, true);
                    } else {
                        sc.anchorScroll('qde_' + id);
                    }
                }
            });
        };
    })
    .controller('GoodsCtrl', function ($scope) {
    })
    .controller('QingdanModalCtrl', ['$scope', 'parameters', 'appModals', 'ApiService', '$ionicScrollDelegate', '$location', function ($scope, parameters, appModals, ApiService, $ionicScrollDelegate, $location) {
        console.log('QingdanModalCtrl');
        $scope.scrollTo = function (id) {
            $location.hash('qd_' + id);
            $ionicScrollDelegate._instances.map(function (sc) {
                if (sc.$$delegateHandle == 'qingdanScroll') {
                    sc.anchorScroll('qd_' + id);
                }
            });
            //$ionicScrollDelegate.anchorScroll('#p_' + id);
        };
        $scope.gotoQingdan = function (item_id) {
            ApiService.qingdan(item_id).then(function (rsdata) {
                ApiService.favs(rsdata, function () {
                    $scope.info = rsdata;
                    console.log(rsdata);
                })
            });
            $ionicScrollDelegate._instances.map(function (sc) {
                if (sc.$$delegateHandle == 'qingdanScroll') {
                    sc.scrollTop()
                }
            });
        }
        $scope.gotoQingdan(parameters);
        $scope.share = function (dinfo) {
            dinfo = $scope.info;
            var subj = '来自妈妈清单的分享';
            var shtext = '【' + dinfo.name + '】http://www.mamilist.com/qingdan/' + dinfo.id;
            window.plugins.socialsharing.share(shtext, subj);
        }
    }]);
