angular.module('starter.services', ['angular-cache'])
    //http://codepen.io/julianpaulozzi/pen/wBgpjM
    .factory('appModals', ['appModalService', function (appModalService) {
        var service = {
            good: viewGood,
            qingdan: viewQingdan,
            favs: viewFavs,
            contact: viewContact,
            setting: viewSetting
        };
        return service;
        function viewSetting(favstype) {
            return appModalService.show('templates/model/setting.html', 'SettingModalCtrl', favstype);
        }

        function viewContact(favstype) {
            return appModalService.show('templates/model/contact.html', 'ContactModalCtrl', favstype);
        }

        function viewFavs(favstype) {
            return appModalService.show('templates/model/favs.html', 'FavsModalCtrl as vm', favstype);
        }

        function viewGood(item_id) {
            return appModalService.show('templates/model/item.html', 'GoodModalCtrl as vm', item_id);
        }

        function viewQingdan(item_id) {
            return appModalService.show('templates/model/qingdan.html', 'QingdanModalCtrl as vm', item_id);
        }
    }])
    .factory('appModalService',
    ['$ionicModal', '$rootScope', '$q', '$injector', '$controller', function ($ionicModal, $rootScope, $q, $injector, $controller) {
        return {
            show: show
        }
        function show(templeteUrl, controller, parameters, options, api) {
            // Grab the injector and create a new scope
            var deferred = $q.defer(),
                ctrlInstance,
                modalScope = $rootScope.$new(),
                thisScopeId = modalScope.$id,
                defaultOptions = {
                    animation: 'slide-left-right-ios7',
                    focusFirstInput: false,
                    backdropClickToClose: true,
                    hardwareBackButtonClose: true,
                    modalCallback: null
                };
            options = angular.extend({}, defaultOptions, options);
            $ionicModal.fromTemplateUrl(templeteUrl, {
                scope: modalScope,
                animation: options.animation,
                focusFirstInput: options.focusFirstInput,
                backdropClickToClose: options.backdropClickToClose,
                hardwareBackButtonClose: options.hardwareBackButtonClose
            }).then(function (modal) {
                modalScope.modal = modal;
                modalScope.openModal = function () {
                    modalScope.modal.show();
                };
                modalScope.closeModal = function (result) {
                    deferred.resolve(result);
                    modalScope.modal.hide();
                };
                modalScope.$on('modal.hidden', function (thisModal) {
                    if (thisModal.currentScope) {
                        var modalScopeId = thisModal.currentScope.$id;
                        if (thisScopeId === modalScopeId) {
                            deferred.resolve(null);
                            _cleanup(thisModal.currentScope);
                        }
                    }
                });
                // Invoke the controller
                var locals = {'$scope': modalScope, 'parameters': parameters};
                var ctrlEval = _evalController(controller);
                ctrlInstance = $controller(controller, locals);
                if (ctrlEval.isControllerAs) {
                    ctrlInstance.openModal = modalScope.openModal;
                    ctrlInstance.closeModal = modalScope.closeModal;
                }
                modalScope.modal.show()
                    .then(function () {
                        modalScope.$broadcast('modal.afterShow', modalScope.modal);
                    });
                if (angular.isFunction(options.modalCallback)) {
                    options.modalCallback(modal);
                }
            }, function (err) {
                deferred.reject(err);
            });
            return deferred.promise;
        }

        function _cleanup(scope) {
            scope.$destroy();
            if (scope.modal) {
                scope.modal.remove();
            }
        }

        function _evalController(ctrlName) {
            var result = {
                isControllerAs: false,
                controllerName: '',
                propName: ''
            };
            var fragments = (ctrlName || '').trim().split(/\s+/);
            result.isControllerAs = fragments.length === 3 && (fragments[1] || '').toLowerCase() === 'as';
            if (result.isControllerAs) {
                result.controllerName = fragments[0];
                result.propName = fragments[2];
            } else {
                result.controllerName = ctrlName;
            }
            return result;
        }
    }]).factory('ApiService', function ($q, $http, CacheFactory) {
        CacheFactory('dataCache', {
            maxAge: 24 * 60 * 60 * 1000 * 1,
            cacheFlushInterval: 24 * 60 * 60 * 1000 * 3,
            deleteOnExpire: 'aggressive',
            storageMode: 'localStorage'
        });
        CacheFactory('localCache', {
            maxAge: 24 * 60 * 60 * 1000 * 366,
            deleteOnExpire: 'none',
            storageMode: 'localStorage'
        });
        var localData = function (lkey, lval) {
            var deferred = $q.defer();
            var dataCache = CacheFactory.get('localCache');
            if (typeof lval === 'undefined') {
                var cachedata = dataCache.get(lkey);
                if (cachedata) {
                    deferred.resolve(cachedata);
                } else {
                    deferred.resolve(null);
                }
                return deferred.promise;
            }
            lval = typeof lval !== 'undefined' ? lval : null;
            if (lval === false) {
                dataCache.remove(lkey);
                deferred.resolve(true);
            }
            else {
                dataCache.put(lkey, lval);
                deferred.resolve(true);
            }
            return deferred.promise;
        }
        var getServerData = function (apiurl, usecache, cachekey) {
            var baseurl_api = baseurl + 'app_api/';
            usecache = usecache || false;
            //usecache = false;
            cachekey = cachekey || false;
            apiurl = apiurl || '';
            var deferred = $q.defer();
            if (usecache && cachekey) {
                var dataCache = CacheFactory.get('dataCache');
                var cachedata = dataCache.get(cachekey);
                if (cachedata) {
                    deferred.resolve(cachedata);
                } else {
                    $http.jsonp(baseurl_api + apiurl + '&callback=JSON_CALLBACK').success(function (data) {
                        dataCache.put(cachekey, data);
                        deferred.resolve(data);
                    }).error(function (err) {
                        showMsg(err);
                        deferred.resolve(false);
                    });
                }
            } else {
                $http.jsonp(baseurl_api + apiurl + 'callback=JSON_CALLBACK').success(function (data) {
                    deferred.resolve(data);
                }).error(function (err) {
                    showMsg(err);
                    deferred.resolve(false);
                });
            }
            return deferred.promise;
        }
        return {
            //hotqingdans  steps  qingdans:step qingdan:id good:id goods:step:cate baikes:topic baike:id me:type:time push:type:time version
            randColor: function (index) {
                var colors = ['red2', 'purple1', 'orange', 'red1', 'blue1', 'purple2', 'blue2', 'blue3', 'green'];
                index = index % colors.length;
                return colors[index];
            },
            hotqingdans: function () {
                return getServerData('?obj=hotqingdans&', true, 'hotqingdans');
            },
            steps: function () {
                return getServerData('?obj=steps&', true, 'tsteps');
            },
            qingdans: function (step) {
                return getServerData('?obj=qingdans&step=' + step + '&', false);
            },
            qingdan: function (id) {
                return getServerData('?obj=qingdan&id=' + id + '&', false);
            },
            good: function (id) {
                return getServerData('?obj=good&id=' + id + '&', false);
            },
            goods: function (step, cate) {
                return getServerData('?obj=goods&step=' + step + '&cate=' + cate, false);
            },
            baike: function (id) {
                return getServerData('?obj=baike&id=' + id + '&', false);
            },
            baikes: function (topic) {
                return getServerData('?obj=baikes&topic=' + topic + '&', false);
            },
            version: function () {
                return getServerData('?obj=version&', false);
            },
            contact: function () {
                return getServerData('?obj=info&', false);
            },
            info: function (id) {
                return getServerData('?obj=info&id=' + id + '&', false);
            },
            push: function (type, time, cb) {
                if (type == null) {
                    localData('me').then(function (rs) {
                        getServerData('?obj=push&type=' + rs.type + '&time=' + rs.time + '&', false).then(cb);
                    })
                } else {
                    getServerData('?obj=push&type=' + type + '&time=' + time + '&', false).then(cb);
                }
            },
            //统计接口
            stats: function (stype) {
                //开启
                if (stype === 'open') {
                    localData('open').then(function (rsdata) {
                        rsdata = rsdata || false;
                        if (rsdata) {
                            getServerData('?obj=stats&type=open&', false);
                            getServerData('?obj=stats&type=reopen&', false);
                        } else {
                            getServerData('?obj=stats&type=ins&', false);
                            getServerData('?obj=stats&type=open&', false);
                        }
                        localData('open', true);
                    })
                }
                //去购买
                if (stype === 'gobuy') {
                    getServerData('?obj=stats&type=gobuy&', false);
                }
            },
            //favs
            favs: function (datas, cb) {
                localData('favs').then(function (rsdata) {
                    var favs = {
                        mami: [],
                        baby: []
                    };
                    favs = rsdata || favs;
                    favs.mami = favs.mami || [];
                    favs.baby = favs.baby || [];
                    datas.p.map(function (data) {
                        data.faved = false;
                        data.fav_class = 'ion-ios-checkmark-outline';
                        data.fav_tit = '收藏';
                        favs.mami.map(function (pid) {
                            if (data.id == pid) {
                                data.faved = true;
                                data.fav_class = 'ion-ios-checkmark';
                                data.fav_tit = '已收藏';
                                return;
                            }
                        })
                        favs.baby.map(function (pid) {
                            if (data.id == pid) {
                                data.faved = true;
                                data.fav_class = 'ion-ios-checkmark';
                                data.fav_tit = '已收藏';
                                return;
                            }
                        })
                    })
                    return cb(favs);
                });
            },
            //喜欢
            like: function (dinfo, type, cb) {
                localData('favs').then(function (rsdata) {
                    var favs = {
                        mami: [],
                        baby: []
                    };
                    favs = rsdata || favs;
                    favs.mami = favs.mami || [];
                    favs.baby = favs.baby || [];
                    type = dinfo.type || type;
                    //console.log(dinfo);
                    var arr = null;
                    if (type == 1) {
                        arr = favs.mami;
                    } else {
                        arr = favs.baby;
                    }
                    var pos = arr.indexOf(dinfo.base_id);
                    //is not fav
                    if (pos === -1) {
                        arr.push(dinfo.base_id);
                        dinfo.faved = true;
                        dinfo.fav_class = 'ion-ios-checkmark';
                        dinfo.fav_tit = '已收藏';
                    } else {
                        arr.splice(pos, 1);
                        dinfo.faved = false;
                        dinfo.fav_class = 'ion-ios-checkmark-outline';
                        dinfo.fav_tit = '收藏';
                    }
                    return localData('favs', favs).then(cb)
                })
            },
            me: function (info, cb) {
                if (info == null) {
                    localData('me').then(function (rsdata) {
                        if(!rsdata){
                            rsdata = null;
                        }
                        cb(null, rsdata);
                    });
                } else {
                    var gtype = info.type;
                    var gtime = 0;
                    if (info.type == 2) {
                        info.day = info.day > 6 ? 6 : info.day;
                        info.week = parseInt(info.week);
                        info.day = parseInt(info.day);
                        var now = new Date();
                        now.setHours(0);
                        now.setMinutes(0);
                        now.setSeconds(1);
                        gtime = now.getTime() - (info.week * 7 + info.day) * 24 * 3600 * 1000;
                    }
                    if (info.type == 3) {
                        var now = new Date(info.month + '/' + info.day + '/' + info.year);
                        now.setHours(0);
                        now.setMinutes(0);
                        now.setSeconds(1);
                        gtime = now.getTime();
                    }
                    getServerData('?obj=me&type=' + gtype + '&time=' + gtime + '&', false)
                        .then(function (rsdata) {
                            //console.log(rsdata);
                            localData('me', rsdata);
                            cb(null, rsdata);
                        });
                }
            },
            //我的清单
            mylist: function (cb) {
                localData('favs').then(function (rsdata) {
                    var favs = {
                        mami: [],
                        baby: []
                    };
                    favs = rsdata || favs;
                    favs.mami = favs.mami || [];
                    favs.baby = favs.baby || [];
                    var ids = favs.mami.join(',') + "-" + favs.baby.join(',');
                    return getServerData('?obj=daibybaseids&ids=' + ids + '&', false).then(cb);
                });
            },
        }
    });
